# Settings
%global product_name Reports package for oVirt Virtualization Management
%global product_description oVirt virtualization reports
%global install_poms 0

%global reports_name ovirt-engine-reports
%global reports_java %{_javadir}/%{reports_name}
%global engine_group ovirt
%global engine_user ovirt

%global make_common_opts \\\
        -j1 \\\
        PACKAGE_NAME=%{name} \\\
        RPM_VERSION=%{version} \\\
        RPM_RELEASE=%{release} \\\
        OVIRT_REPORTS_NAME=%{reports_name} \\\
        PREFIX=%{_prefix} \\\
        SYSCONF_DIR=%{_sysconfdir} \\\
        BIN_DIR=%{_bindir} \\\
        DATAROOT_DIR=%{_datadir} \\\
        PYTHON=%{__python} \\\
        PYTHON_DIR=%{python_sitelib} \\\
        JAVA_DIR=%{_javadir} \\\
        MAVENPOM_DIR=%{_mavenpomdir} \\\
        PKG_JAVA_DIR=%{reports_java} \\\
        MVN=true \\\
        %{?BUILD_FLAGS:BUILD_FLAGS="%{BUILD_FLAGS}"} \\\
        %{?EXTRA_BUILD_FLAGS:EXTRA_BUILD_FLAGS="%{EXTRA_BUILD_FLAGS}"}

Name: rhevm-reports
Version: 3.3.2
Release: 3%{?dist}
License: Commercial
Summary: %{product_name}
Group: Virtualization/Management
URL: http://www.ovirt.org
BuildArch: noarch

# We build RHEV-M in the MEAD environment, and that means that the
# sources are the artifacts previously built with maven:

Source0: root-3.3.2-scm-sources.zip
Source1: WebadminLineBarChartTheme-3.3.2.jar
Source2: WebadminLineBarChartTheme-3.3.2.pom
Source3: EngineAuthentication-3.3.2.pom
Source4: EngineAuthentication-3.3.2.jar
Source5: root-3.3.2.pom
Source6: ReportsPieChartTheme-3.3.2.pom
Source7: ReportsPieChartTheme-3.3.2.jar
Source8: CustomOvirtReportsQueryManipulator-3.3.2.pom
Source9: CustomOvirtReportsQueryManipulator-3.3.2.jar
Source10: jars-3.3.2.pom
Source11: ChartsCustomizers-3.3.2.pom
Source12: ChartsCustomizers-3.3.2.jar
Source13: reports-3.3.2.pom
Source14: ReportsLineBarChartTheme-3.3.2.pom
Source15: ReportsLineBarChartTheme-3.3.2.jar

BuildRequires: jpackage-utils
BuildRequires: java-1.7.0-openjdk-devel
BuildRequires: make
BuildRequires: log4j
Requires: python
Requires: python-argparse
Requires: java-1.7.0-openjdk
Requires: jpackage-utils
Requires: rhevm >= 3.3.0
Requires: rhevm-dwh >= 3.3.0
Requires: rhevm-dbscripts >= 3.3.0
Requires: jasperreports-server-pro = 5.5.0-6.el6ev
Requires: m2crypto

# We need some packages installed in order to workaround
# bug 862355:
Requires: liberation-mono-fonts

%description
The %{product_description} package provides a suite of
pre-configured reports and dashboards that enable you to
monitor the system. The reports module is based on
JasperReports and JasperServer, and can also be used to create
ad-hoc reports.

%prep

# We build RHEV-M in the MEAD environment, and that means that the
# sources are archived with root based on repository name

%setup -q -T -b 0 -n rhevm-reports


%build

make %{make_common_opts}

%install
rm -fr "%{buildroot}"

# Use the makefile to do the normal installation, after that we
# will need to replace jar files with links to their actual
# locations:
make %{make_common_opts} install DESTDIR=%{buildroot} MAVEN_OUTPUT_DIR=%{_sourcedir}

# Needed for compatibility if package is different than the directory structure
%if "%{name}" != "%{reports_name}"
    ln -s -f %{_bindir}/%{reports_name}-setup %{buildroot}%{_bindir}/%{name}-setup
    ln -s "%{reports_name}" "%{buildroot}%{reports_java}/../%{name}"
%endif

# Register poms
%if !%{install_poms}
rm -fr "%{buildroot}%{_mavenpomdir}"
%else
for pom in %{buildroot}%{_mavenpomdir}/*.pom
do
  pomdir=`dirname "${pom}"`
  pom=`basename "${pom}"`
  jpppom="JPP.${pom}"
  mv "${pomdir}/${pom}" "${pomdir}/${jpppom}"
  artifact_id=`echo "${pom}" | sed -e 's/^%{name}-//' -e 's/\.pom//'`
  if [ -f "%{buildroot}%{reports_java}/${artifact_id}.jar" ]
  then
    %add_maven_depmap "${jpppom}" "%{name}/${artifact_id}.jar"
  else
    %add_maven_depmap "${jpppom}"
  fi
done
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap
if [ "$1" -eq 0 ]; then
    if [ -d /usr/share/ovirt-engine/%{name}.war ]; then
        rm -rf /usr/share/ovirt-engine/%{name}.war
        rm -rf /var/lib/ovirt-engine/deployments/%{name}.war*
    fi
    if [ -f /etc/ovirt-engine/jrs-deployment.version ]; then
        rm -rf /etc/ovirt-engine/jrs-deployment.version
    fi
    if [ -f /usr/share/ovirt-engine/engine.ear/webadmin.war/webadmin/Reports.xml ]; then
        rm -rf /usr/share/ovirt-engine/engine.ear/webadmin.war/webadmin/Reports.xml
    fi
fi

%files
%dir %attr(-, %{engine_user}, %{engine_group}) %{_sysconfdir}/%{reports_name}/ovirt-engine-reports.conf.d

%{_sysconfdir}/ovirt-engine/engine.conf.d/50-ovirt-engine-reports.conf
%{_sysconfdir}/ovirt-engine/ovirt-engine-reports
%{_sysconfdir}/httpd/conf.d/z-ovirt-engine-reports-proxy.conf
%{reports_java}
%{_datadir}/%{reports_name}
%if "%{name}" != "%{reports_name}"
%{_javadir}/%{name}
%endif
%if %{install_poms}
%{_mavendepmapfragdir}/%{name}
%{_mavenpomdir}/JPP.%{name}-*
%endif

%{_bindir}/%{reports_name}-setup
%if "%{name}" != "%{reports_name}"
%{_bindir}/%{name}-setup
%endif

%changelog
* Tue Mar 11 2014 Yaniv Dary <ydary@redhat.com> - 3.3.2
Fixed issue:
1074909 - setup error on a system installed in Brazilian Portuguese

* Mon Mar 10 2014 Yaniv Dary <ydary@redhat.com> - 3.3.2
Fixes issues:
1059268 - BR18 - the numbers of OSs are incorrect
1064827 - ssl2jkstrust.py does not get root ca from chain in some cases
1072405 - ovirt-engine-reports-setup does not handle escape characters in the 10-setup-database.conf ENGINE_DB_PASSWORD
1072466 - Upgrading reports from 3.2 to 3.3 without Apache running fails and prevents any future setup from succeeding

* Mon Feb 03 2014 Yaniv Dary <ydary@redhat.com> - 3.3.1
Fixed issues:
- remote user password is asked twice for authentication (#1057277)
- BR18 - the numbers of OSs are incorrect (#1059268)

* Mon Jan 13 2014 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issue:
When upgrading from 3.2/3.1 and using postgres user as remote user, setup fails. (#1049468)

* Wed Dec 18 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issues:
- update error handling in remote DB flow (#1039946)
- update reports DB schema on major release upgrade (#1043530)
- backup DB and WAR on upgrade (#1043314)
- rename config values to match engine convention (#1043957)
- remove 10-setup-database-reports.conf from package (#1043957)
- rename engine-reports.conf.d to ovirt-engine-reports.conf.d (#1043957)

* Mon Dec 09 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issue:
- changed db name to branded (#1039459)

* Tue Dec 03 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issues:
- Refixed update remote DB creation instructions (#1021556)
- Fixed br18 os detection (#1031612)

* Tue Nov 26 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issue:
- fixed redirect to reports to not show resend dialog (#1033090)

* Sun Nov 24 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issues:
- removed servlet that causes error at JBoss start
- update db cleanup instructions (#1027378)
- set correct umask for execution

* Thu Nov 21 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issues:
- returned basic auth to html login chain (#1020340)
- enable full text in ods export format (#722819)
- updated default theme to have correct favicon
- updated JRS branded translation files

* Wed Nov 13 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed the following setup issues:
update DB configuration reading (#1026089)
update psql version detection
add answerfile option (#1025339)

* Wed Nov 06 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed the following setup issues:
- Fixed the engine database name parameter (#1024797)
- Added remote DB/user creation instructions (#1021556)
- Added check for existing configuration files (#1026091)
- Fixed prompting the admin password (#1026093)

* Thu Oct 31 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Changed the db dict get method (#1024797)

* Tue Oct 29 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Updated admin user password prompt.
Also fixed issues:
- Applied temporary fix for SSO solution (#1020340)
- Made customizations compatible with JRS 5.5 GA (#1010680)

* Wed Oct 23 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issue:
986734 - require specific JRS 5.5.0 package

* Tue Oct 15 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issues:
- only update lang on systems with postgres >9.2 (#1011549)
- added systemd support (#1011546)

* Tue Oct 08 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed:
- stop and warn if setup is not run as root user (#853957)

* Tue Sep 24 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Updated localiztion files (#963652)

* Mon Sep 16 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed customizations to work with JRS 5.5 Drop 2.
Also added various history columns to domains\topics.

* Mon Sep 09 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed verious installation issues with engine otopi setup.
Setup now works in clean local\remote setup of 3.3.
Also made changes needed for JRS 5.5 rebase.

Bug fixed:
990942 - reports setup fails after running otopi engine setup 
967349 - PRD33 - rebase jasper server to 5.x 

* Mon Jul 15 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Refixed issues:
- 977830 - reslove logging issues with JRS
- 977111 - added restart of httpd service to reload proxy

* Tue Jul 09 2013 Yaniv Dary <ydary@redhat.com> - 3.3.0
Fixed issues:
- 970545 - ovirt-engine-reports-setup doesn't support option --help
- 973675 - [rhevm-reports] - Setup - Incorrect installation instructions for dwh (ovirt-engine-dwh-setup)
- 974152 - ovirt xml configuration needs a password update
- 975812 - [rhevm-reports] - Uninstall - Dashboard Tab is not removed from Webadmin (Uninstall DWH+Reports)
- 977111 - [rhevm-reports_33] - Reports - Reports Portal is unavailable

* Mon May 27 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Fixed issue:
967276 - BR9 - Report gives exception

* Wed May 08 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Fixed issue:
952469 - [ja_JP] [zh_CN] [Reports Portal] Dashboard -> garbled text

* Wed May 08 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Fixed issue:
952438 - [fr-FR] - [Reports Portal] - View-Search Results - Inventory Dashboard/Run and /Open in Designer

* Thu Mar 21 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Updated manifest file and localization files.

Fixed issues:
921446 - [rhevm-reports] - Update manifest file for 3.2
918075 - [rhevm-reports] - Input Controls and Reports Unites Complete Localization of RHEVM Reports

* Tue Feb 28 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Fixed issues:
906282 - [rhevm-reports] - Ad Hoc - Create new Ad Hoc Report Doesn't display version "3.2"
910778 - [rhevm-reports] - BR45 - Report Displays VM session Date without Time (Users' Spice Sessions Activity)
912302 - [rhevm-reports] - BR46 - Displays Incorrect data (Single Virtual Machine Uptime (BR46))
913081 - [rhevm-reports] - RFE BR44 - Calculate the correct time for a partial hour or less than 1Hour (CCP (certified cloud provider) report)
913084 - [rhevm-reports] - RFE - Reports - Incorrect values list order for all reports with IC "Period Range"

* Tue Feb 21 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Fixed issue:
906282 -[rhevm-reports] - Ad Hoc - Create new Ad Hoc Report Doesn't display version "3.2"

* Tue Feb 05 2013 Yaniv Dary <ydary@redhat.com> - 3.2.0
Issues fixed:
- 870017 - When clicking on "Need help logging in?" in the jasperserver login page it displays the default jasper credentials and not the rhevm ones.
- 892306 - [rhevm-reports] - Input Controls and Reports Unites Complete Localization of RHEVM Reports
- 892940 - [rhevm-reports] Webadmin Dashboard - Cluster dashboard contains " in charts headlines
- 894684 - [rhevm-reports] Webadmin Reports Menu - Missing reports (BR44,BR47,BR45)
- 901418 - [ja][zh] [rhevm-reports] Local strings displayed as square in 'Active Virtual Machines' OS Over Time' report.

* Thu Dec 27 2012 Yaniv Dary <ydary@redhat.com> - 3.2.0
- report now work with 3.2 dwh views.
- some reports feature interactive tables.

New features and issues fixed:
871737 - fixed br2c network chart tooltip
871751 - fixed br23 chart tooltip
882648 - [rhevm-reports] newly created Ad Hoc View shows non-formatted field names
772918 - PRD32 - RFE - Storage Inventory Report - New report
854949 - PRD32 - [rhevm-reports] - Dashboard - RFE - DC Dashboard should display Storage Domains count
862019 - PRD32 - rhevm-reports should be able to report uptime against virtual machines, in addition to cluster
873238 - [rhevm-reports] Webadmin Dashboard - Cluster Dashboard headline covers the Cluster's status (DR13)
876085 - [rhevm-reports] - BR10 - doesnt display IO chart in "Resource Usage of VM..." -> Top 5 busiest Disk Usage" correctly
880581 - PRD32 - [RFE] [rhevm-reports] Report Daily list of people logged into Spice consoles and their activity
883137 - PRD32 - [RFE] [rhevm-reports] CCP (certified cloud provider) report

* Sun Nov 4 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
- Update
* Wed Feb 15 2012 Yaniv Dary <ydary@redhat.com> - 3.0.2
- Initial Commit
